import re
from typing import List
C=[]
F=[]


with open("js-objects.md") as fi:
    x=fi.read()
y=re.findall("```(\w+?)```(.*?)(?=`|\n+$)",x,re.DOTALL|re.MULTILINE)
y=[(i,j.replace("\n","")) for i,j in y]
#y=[(i,j) for i,j in y if re.match("DROID|DORDER",i)]
C.extend(y)

with open("js-functions.md") as fi:
    x=fi.read()
y=re.findall("```([A-Z_]+?)```",x,re.DOTALL|re.MULTILINE)
y=[(i,"") for i in y]
#y=[(i,j) for i,j in y if re.match("DROID|DORDER",i)]
C.extend(y)


def sub2(y:List[str]):
    y=[(re.sub("<|>|\[|\]","",i),j) for i,j in y] 
    y=[(re.sub("\|","=",i),j) for i,j in y] 
    y=[(re.sub("(\w+?)\.\.\.",lambda i:"..."+i.group(1),i),j) for i,j in y] 
    return y

with open("js-functions.md") as fi:
    x=fi.read()
y=re.findall("## (.*?)\n\n(.*?)(?=#|\n+$)",x,re.DOTALL|re.MULTILINE)
y=sub2(y)
F.extend(y)

with open("js-events.md") as fi:
    x=fi.read()
y=re.findall("## (.*?)\n\n(.*?)(?=#|\n+$)",x,re.DOTALL|re.MULTILINE)
y=sub2(y)
F.extend(y)



C.sort(key=lambda x:(x[0],-len(x[1])))
F.sort()

def match2(entry:str):
    fname=re.match("\w+",entry).group()
    args:list[str]=re.findall("[\w.]+",entry.replace(fname,""))
    return fname,args

def jsdoc_return(fname:str,doc:str):
    rt=[]
    if re.match("enum|find|get",fname):
        rtc="object"
        arr="%s"
        if re.match("enum|find",fname):
            arr="[%s]"
        if re.match("get",fname):
            rtc=""
        rtyp=re.search("Research|Droid|Struct|Object",fname)
        if rtyp:
            rtc=rtyp.group().lower()
        if fname=="enumCargo":
            rtc="droid"
        if re.search("Limit",fname):
            rtc=""
        rt.append(arr%(rtc+"0"))

    if "Return" in doc:
        if re.search("Returns?.{0,20}(boolean|whether|true|false|status)",doc):
            rt.append("true")
        if re.search("Returns?.{0,20}(num|limit|amount)",doc):
            rt.append("0")
        if re.search("Returns?.{0,20}(string)",doc):
            rt.append("''")
        if re.search("Returns?.{0,20}(null)",doc):
            rt.append("null")  

    if re.match("count|dist",fname):
        rt.append("0")

    _except={
        "enumLabels":["''"],
        "enumCargo":["[droid0]"],
        "pickStructLocation":["object0"],
        "componentAvailable":["true"],
        "makeTemplate":["droid0"],
        "addDroid":["droid0"],
        "addFeature":["object0"],
        "addStructure":["struct0"],
        "getScrollLimits":["object0"],
    }
    if fname in _except:
        rt=_except[fname]
    return ";".join(["return "+i for i in set(rt)])

def jsdoc_arg(arg:str):
    base="@param {%s} %s"
    typ=""
    if re.match("((x|y|z|player|viewer|group)[0-9]?)|(((ambient|diffuse|specular)_)?[rgb])|(from|to|amount|time|health)$",arg,re.I):
        typ="Number"
    if re.search("(id|Id)",arg):        
        typ="Number"
    if re.search("object|victim|attacker|target",arg,re.I):
        typ="_object"      
    if re.search("droid|transport",arg,re.I):
        typ="_droid"     
    if re.search("structure|factory",arg,re.I):
        typ="_struct"
    if re.search("filter|limit|flag|order|power|value|number|speed|direction|scale|seconds|experience|expiry|colour",arg,re.I):
        typ="Number"
    if re.search("name|message|label|prefix|sound|path|string",arg,re.I):
        typ="String"
    if re.search("type",arg,re.I):
        typ="Number"
    if re.search("enable|status|entered|seen",arg,re.I):
        typ="Boolean"
    if arg=="reserved":
        typ='""'
    _except={
        "body":"String[]|String",
        "propulsion":"String[]|String",
        "...turrets":"String[]|String",
        "objects":"_object[]"
    }
    if arg in _except:
        typ=_except[arg]

    if re.match("\.\.\.",arg):
        typ="(%s)[]"%typ
        arg=arg.replace("...","")
    return base%(typ,arg)


def jsdoc(entry:str,doc:str):
    fname,args=match2(entry)
    retdoc=jsdoc_return(fname,doc)
    argsdoc=["\n* "+jsdoc_arg(i) for i in args]

    base="/** %s %s\n*/\nfunction %s {%s}"

    return base%(doc,"".join(argsdoc),entry,retdoc)

def constdoc(cname:str,doc:str):
    base="/**%s*/\nconst %s=%s\n"
    return base%(doc.strip(),cname,"'%s'"%cname)


d=[]
with open("pylint.js","w") as fi:
    with open("object0.js") as fi2:
        fi.write(fi2.read())
    for cname,doc in C:
        cname:str
        doc:str  
        if cname!=cname.upper():
            continue
        if cname in d:
            continue
        d.append(cname)
        print(constdoc(cname,doc),file=fi)


    for entry,doc in F:
        print(jsdoc(entry,doc),file=fi)
        print(f"",file=fi)

    with open("globals0.js") as fi2:
        fi.write(fi2.read())

